package com.sun.xml.internal.bind.v2.runtime.property;

import com.sun.xml.internal.bind.v2.model.runtime.RuntimePropertyInfo;
import com.sun.xml.internal.bind.v2.runtime.reflect.Accessor;
import com.sun.xml.internal.bind.v2.model.core.PropertyKind;
import javax.xml.stream.XMLStreamException;
import java.io.IOException;
import org.xml.sax.SAXException;
import com.sun.xml.internal.bind.v2.runtime.XMLSerializer;
import com.sun.xml.internal.bind.api.AccessorException;

public interface Property<BeanT> extends StructureLoaderBuilder
{
    public abstract void reset(BeanT p0) throws AccessorException;
    
    public abstract void serializeBody(BeanT p0, XMLSerializer p1, Object p2) throws SAXException, AccessorException, IOException, XMLStreamException;
    
    public abstract void serializeURIs(BeanT p0, XMLSerializer p1) throws SAXException, AccessorException;
    
    public abstract boolean hasSerializeURIAction();
    
    public abstract String getIdValue(BeanT p0) throws AccessorException, SAXException;
    
    public abstract PropertyKind getKind();
    
    public abstract Accessor getElementPropertyAccessor(String p0, String p1);
    
    public abstract void wrapUp();
    
    public abstract RuntimePropertyInfo getInfo();
    
    public abstract boolean isHiddenByOverride();
    
    public abstract void setHiddenByOverride(boolean p0);
    
    public abstract String getFieldName();
}
